EDIT - bug #6480

Re-saved by cascade in specimen bulk editor
03/02/2017 04:43 PM - Andreas Mdller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 4.7

Severity: normal Found in Version:

Description

When trying to delete a specimen that belongs to a field unit and that does have a sibling specimen | get the following exception, if all
3 specimenOrObservations are shown in the bulk editor.

To reproduce you may create in specimen tree editor a field with locality "yyyy" and add 2 child specimen. Go to bulk editor, search
for "yyyy". 3 units should show up. Delete one of the 2 derived units, => exception.

login : admin
editor version : 4.6.0.201702272351
server : test.e-taxonomy.eu (edit-test) / cichorieae
schema version : 4.1.0.0.201607300000
os : Windows Server 2012 R2 6.3 amd64
java : 1.8.0_121
org.hibernate.ObjectDeletedException: deleted object would be re-saved by cascade (remove deleted
object from associations): [eu.etaxonomy.cdm.model.occurrence.DerivedUnit#5202]

at org.hibernate.internal.SessionImpl.forceFlush(SessionImpl.java:1301)

at org.hibernate.event.internal.DefaultSaveOrUpdateEventListener.entityIsTransient (DefaultSave
OrUpdateEventListener.java:170)

at org.hibernate.event.internal.DefaultSaveOrUpdateEventListener.performSaveOrUpdate (DefaultSa
veOrUpdateEventListener. java:97)

at org.hibernate.event.internal.DefaultSaveOrUpdateEventListener.onSaveOrUpdate (DefaultSaveOrU
pdateEventListener. java:73)

at org.hibernate.internal.SessionImpl.fireSaveOrUpdate (SessionImpl. java:648)

at org.hibernate.internal.SessionImpl.saveOrUpdate (SessionImpl. java:640)

at org.hibernate.engine.spi.CascadingActions$5.cascade (CascadingActions. java:218)

at org.hibernate.engine.internal.Cascade.cascadeToOne (Cascade. java:398)

at org.hibernate.engine.internal.Cascade.cascadeAssociation (Cascade. java:323)

at org.hibernate.engine.internal.Cascade.cascadeProperty (Cascade.java:162)

at org.hibernate.engine.internal.Cascade.cascadeCollectionElements (Cascade.java:431)

at org.hibernate.engine.internal.Cascade.cascadeCollection (Cascade.java:363)

at org.hibernate.engine.internal.Cascade.cascadeAssociation (Cascade.java:326)

at org.hibernate.engine.internal.Cascade.cascadeProperty (Cascade.java:162)

at org.hibernate.engine.internal.Cascade.cascade (Cascade.java:111)

at org.hibernate.event.internal.AbstractFlushingEventListener.cascadeOnFlush (AbstractFlushingE
ventListener. java:150)

at org.hibernate.event.internal.AbstractFlushingEventListener.prepareEntityFlushes (AbstractFlu
shingEventListener. java:141)

at org.hibernate.event.internal.AbstractFlushingEventListener.flushEverythingToExecutions (Abst
ractFlushingEventListener. java:74)

at org.hibernate.event.internal.DefaultFlushEventListener.onFlush (DefaultFlushEventListener. ja
va:38)

at org.hibernate.internal.SessionImpl.flush(SessionImpl.java:1282)

at org.hibernate.internal.SessionImpl.managedFlush (SessionImpl. java:465)

at org.hibernate.internal.SessionImpl.flushBeforeTransactionCompletion (SessionImpl. java:2963)

at org.hibernate.internal.SessionImpl.beforeTransactionCompletion (SessionImpl. java:2339)

at org.hibernate.engine. jdbc.internal.JdbcCoordinatorImpl.beforeTransactionCompletion (JdbcCoor
dinatorImpl. java:485)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelocalTransactionCoordi
natorImpl.beforeCompletionCallback (JdbcResourceLocalTransactionCoordinatorImpl. java:147)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelLocalTransactionCoordi
natorImpl.access$100 (JdbcResourcelLocalTransactionCoordinatorImpl. java:38)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelocalTransactionCoordi
natorImpl$TransactionDriverControlImpl.commit (JdbcResourceLocalTransactionCoordinatorImpl. java:231
)

at org.hibernate.engine.transaction.internal.TransactionImpl.commit (TransactionImpl. java:65)

at org.springframework.orm.hibernate5.HibernateTransactionManager.doCommit (HibernateTransactio
nManager. java:581)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.processCommit (Ab
stractPlatformTransactionManager. java:761)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.commit (AbstractP
latformTransactionManager. java:730)

at org.springframework.transaction.interceptor.TransactionAspectSupport.commitTransactionAfter
Returning (TransactionAspectSupport. java:485)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransactio
n(TransactionAspectSupport. java:291)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInterc
eptor. java:96)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$Proxy2769.delete (Unknown Source)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:497)

at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:302)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMeth
odInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:157)

at org.springframework.remoting.support.RemoteInvocationTracelnterceptor.invoke (RemoteInvocati
onTraceInterceptor.java:78)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$Proxy3045.delete (Unknown Source)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:497)

at org.springframework.remoting.support.RemoteInvocation.invoke (RemoteInvocation. java:212)

at org.springframework.remoting.support.DefaultRemoteInvocationExecutor.invoke (DefaultRemotelIn
vocationExecutor. java:39)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invoke (RemoteInvocationB
asedExporter. java:78)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invokeAndCreateResult (Re
moteInvocationBasedExporter.java:114)

at org.springframework.remoting.httpinvoker.HttpInvokerServiceExporter.handleRequest (HttpInvok
erServiceExporter. java:74)

at org.springframework.web.servlet.mvc.HttpRequestHandlerAdapter.handle (HttpRequestHandlerAdap
ter.java:51)

at org.springframework.web.servlet.DispatcherServlet.doDispatch (DispatcherServlet.java:959)

at org.springframework.web.servlet.DispatcherServlet.doService (DispatcherServlet. java:893)

at org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServlet.java:969)

at org.springframework.web.servlet.FrameworkServlet.doPost (FrameworkServlet. java:871)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:707)

at org.springframework.web.servlet.FrameworkServlet.service (FrameworkServlet. java:845)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:790)

at org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder. java:808)

at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler.java:1669)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:316)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.invoke (FilterSe
curityInterceptor.java:126)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.doFilter (Filter
SecurityInterceptor. java:90)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:330)

at org.springframework.security.web.access.ExceptionTranslationFilter.doFilter (ExceptionTransl
at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1652)

at org.eclipse.jetty.servlet.ServletHandler.doHandle (ServletHandler. java:585)

at org.eclipse.jetty.server.handler.ScopedHandler.handle (ScopedHandler. java:143)

at org.eclipse.jetty.security.SecurityHandler.handle (SecurityHandler. java:577)

at org.eclipse.jetty.server.session.SessionHandler.doHandle (SessionHandler. java:223)

at org.eclipse.jetty.server.handler.ContextHandler.doHandle (ContextHandler. java:1127)

at org.eclipse.jetty.servlet.ServletHandler.doScope (ServletHandler. java:515)

at org.eclipse.jetty.server.session.SessionHandler.doScope (SessionHandler. java:185)

at org.eclipse.jetty.server.handler.ContextHandler.doScope (ContextHandler. java:1061)

at org.eclipse.jetty.server.handler.ScopedHandler.handle (ScopedHandler.java:141)

at org.eclipse.jetty.server.handler.ContextHandlerCollection.handle (ContextHandlerCollection.j
ava:215)

at org.eclipse.jetty.server.handler.HandlerWrapper.handle (HandlerWrapper. java:97)

at org.eclipse.jetty.server.Server.handle (Server. java:497)

at org.eclipse.jetty.server.HttpChannel.handle (HttpChannel. java:310)

at org.eclipse.jetty.server.HttpConnection.onFillable (HttpConnection. java:257)

at org.eclipse.jetty.io.AbstractConnection$2.run (AbstractConnection. java:540)

at org.eclipse.jetty.util.thread.QueuedThreadPool.runJob (QueuedThreadPool. java:635)
at org.eclipse.jetty.util.thread.QueuedThreadPool$3.run (QueuedThreadPool. java:555)

at java.lang.Thread.run (Thread. java:745)

at org.springframework.remoting.support.RemoteInvocationUtils.fillInClientStackTraceIfPossible
(RemoteInvocationUtils. java:45)

at org.springframework.remoting.support.RemoteInvocationResult.recreate (RemoteInvocationResult
.jJava:149)

at org.springframework.remoting.support.RemoteInvocationBasedAccessor.recreateRemoteInvocation
Result (RemoteInvocationBasedAccessor. java:85)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (HttpInvokerCli
entInterceptor. java:150)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$Proxy39.delete (Unknown Source)

at eu.etaxonomy.taxeditor.bulkeditor.input.OccurrenceEditorInput.delete (OccurrenceEditorInput.
java:114)

at eu.etaxonomy.taxeditor.bulkeditor.input.OccurrenceEditorInput.delete (OccurrenceEditorInput.
java:1l)

at eu.etaxonomy.taxeditor.annotatedlineeditor.AnnotatedLineDocumentProvider.doSaveDocument (Ann
otatedLineDocumentProvider. java:280)

at org.eclipse.ui.texteditor.AbstractDocumentProvider$lS$SaveOperation.execute (AbstractDocument
Provider.java:610)

at org.eclipse.ui.texteditor.AbstractDocumentProvider$DocumentProviderOperation.run (AbstractDo
cumentProvider. java:74)

at org.eclipse.ui.texteditor.AbstractDocumentProvider.executeOperation (AbstractDocumentProvide
r.java:553)

at org.eclipse.ui.texteditor.AbstractDocumentProvider.saveDocument (AbstractDocumentProvider. ja
va:629)

at org.eclipse.ui.texteditor.AbstractTextEditor.performSave (AbstractTextEditor. java:5048)

at org.eclipse.ui.texteditor.AbstractTextEditor.doSave (AbstractTextEditor.java:4837)

at eu.etaxonomy.taxeditor.annotatedlineeditor.AnnotatedLineEditor.doSave (AnnotatedLineEditor.j
ava:250)

at eu.etaxonomy.taxeditor.bulkeditor.BulkEditor.doSave (BulkEditor.java:263)

at org.eclipse.uil.texteditor.AbstractTextEditor$TextEditorSavable.doSave (AbstractTextEditor. ja
va:7177)

at org.eclipse.ui.Saveable.doSave (Saveable.java:214)

at org.eclipse.ui.internal.SaveableHelper.doSaveModel (SaveableHelper. java:349)

at org.eclipse.ui.internal.SaveableHelper$3.run (SaveableHelper. java:195)

at org.eclipse.ui.internal.SaveableHelper$5.run (SaveableHelper. java:277)

at org.eclipse.jface.operation.ModalContext.runInCurrentThread (ModalContext.java:464)

at org.eclipse.jface.operation.ModalContext.run (ModalContext. java:372)

at org.eclipse.jface.window.ApplicationWindow$1l.run (ApplicationWindow. java:759)

at org.eclipse.swt.custom.BusyIndicator.showWhile (BusyIndicator. java:70)

at org.eclipse.jface.window.ApplicationWindow.run (ApplicationWindow. java:756)

at org.eclipse.ui.internal.WorkbenchWindow.run (WorkbenchWindow. java:2649)

at org.eclipse.ui.internal.SaveableHelper.runProgressMonitorOperation (SaveableHelper. java:285)

at org.eclipse.ui.internal.SaveableHelper.runProgressMonitorOperation (SaveableHelper. java:264)

at org.eclipse.ui.internal.SaveableHelper.saveModels (SaveableHelper.java:207)

at org.eclipse.ui.internal.SaveableHelper.savePart (SaveableHelper. java:144)

at org.eclipse.ui.internal.EditorManager.savePart (EditorManager.java:1399)

at org.eclipse.ui.internal.WorkbenchPage.savePart (WorkbenchPage.java:3416)

at org.eclipse.ui.internal.WorkbenchPage.saveEditor (WorkbenchPage.java:3429)

at org.eclipse.ui.internal.handlers.SaveHandler.execute (SaveHandler. java:54)

at org.eclipse.ui.internal.handlers.HandlerProxy.execute (HandlerProxy. java:293)

at org.eclipse.core.commands.Command.executeWithChecks (Command. java:476)

at org.eclipse.core.commands.ParameterizedCommand.executeWithChecks (ParameterizedCommand. java:
508)

at org.eclipse.ui.internal.handlers.HandlerService.executeCommand (HandlerService.java:169)

at org.eclipse.ui.internal.handlers.SlaveHandlerService.executeCommand (SlaveHandlerService. jav
a:241)

at org.eclipse.ui.menus.CommandContributionItem.handleWidgetSelection (CommandContributionItem.
java:829)

at org.eclipse.ui.menus.CommandContributionItem.access$19 (CommandContributionItem. java:815)

at org.eclipse.ui.menus.CommandContributionItem$5.handleEvent (CommandContributionItem. java:805

at org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)
at org.eclipse.swt.widgets.Widget.sendEvent (Widget.java:1053)
at org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4165)

at org.eclipse.swt.widgets.Display.readAndDispatch(Display.java:3754)
at org.eclipse.ui.internal.Workbench.runEventLoop (Workbench. java:2701)

at org.eclipse.ui.internal.Workbench.runUI (Workbench.java:2665)

at org.eclipse.ui.internal.Workbench.access$4 (Workbench. java:2499)

at org.eclipse.ui.internal.Workbench$7.run (Workbench. java:679)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:332)

at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:668)

at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:149)

at eu.etaxonomy.taxeditor.Application.start (Application. java:24)

at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196)
at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLaunc

her.java:110)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher. java:

79)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:344)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:179)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:622)

at org.eclipse.equinox.launcher.Main.basicRun (Main. java:577)
at org.eclipse.equinox.launcher.Main.run (Main.java:1410)

Delete works in the specimen tree editor.

Related issues:
Related to EDIT - bug #9846: Improve delete configuration in specimen list ed...

New

Associated revisions

Revision 09a260bb - 04/06/2017 10:43 AM - Katja Luther

fix #6480: fix some problems in delete of specimen

Revision 07dbf1bc - 05/11/2017 10:38 AM - Katja Luther

fix #6480: fix delete of specimenOrObservations

Revision f5ae4e08 - 05/11/2017 10:41 AM - Katja Luther

ref #6480: add deleteConfigurator to bulk editor delete of specimenOrObservation base

History

#1 - 04/04/2017 11:57 AM - Katja Luther

| don't get an exception, but | have to close the Specimen Editor to see the result.

#2 - 04/04/2017 11:57 AM - Katja Luther

- Status changed from New to In Progress

#3 - 04/06/2017 10:44 AM - Katja Luther
- Status changed from In Progress to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|09a260bbd5261aa3635a12edfb0cb1d9tb76424a.

#4 - 05/10/2017 10:23 AM - Katja Luther
- Assignee changed from Katja Luther to Andreas Miiller

- % Done changed from 50 to 80

please review

#5 - 05/10/2017 07:48 PM - Andreas Miuller

- Status changed from Resolved to Feedback
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib/revisions/09a260bbd5261aa3635a12edfb0cb1d9fb76424a

- Assignee changed from Andreas Mtiller to Katja Luther

| still get the exception. Here is what | do in a bit more detail:

1. Open Specimen-Editor
2. Create FieldUnit with locality "xyza"
3. Save
4. Add PreservedSpecimen for the above FieldUnit with Accession Number "2222"
5. Save
6. Add PreservedSpecimen for the above FieldUnit with Accession Number "3333"
7.Save
8. Goto Specimen Bulk Editor
9. Search for "xyza" => should return 3 entries
10. Delete Preserved Specimen entry labeled "3333"
11. Save => exception

#6 - 05/11/2017 10:39 AM - Katja Luther
- Status changed from Feedback to Resolved

- % Done changed from 80 to 50

Applied in changeset cdmlib|07dbf1bcf8687df44cd3e5fcb90acedb4aba71f6.

#7 - 05/11/2017 10:43 AM - Katja Luther
- Status changed from Resolved to Feedback

- % Done changed from 50 to 80

sorry, did not see that the problem was in bulkeditor. now | added the delete configurator to the bulk editor delete and removed the gathering event
from field unit before deletion.

#8 - 05/11/2017 10:44 AM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Miiller

#9 - 06/15/2017 02:42 PM - Andreas Miiller
- File NLS_error.png added
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther
There is a problem with the message displayed in Confirm Deletion dialog. Looks like i18n does not work correctly. See attachement.
#10 - 06/15/2017 02:58 PM - Andreas Miiller

Labels:

e "Delete Children" => "Delete children", to be consistent
e Delete from "Described specimen” => ... "described specimen”

#11 - 06/15/2017 03:09 PM - Andreas Miiller

| wonder if "Delete children" makes sense in bulk editor. This is a flat view. Users may not know what a "child" is. Either we completely remove it or
we adjust it to "Delete all derived units". This is different in the Specimen-Editor where the tree is visible and therefore it might be clearer what is
meant by "child".

#12 - 06/15/2017 03:24 PM - Andreas Miiller

The original problem seems to be solved. So if above issues are not easy to fix please move to a new ticket and close this one.

#13 - 11/03/2021 02:32 PM - Katja Luther

Andreas Muller wrote:

There is a problem with the message displayed in Confirm Deletion dialog. Looks like i18n does not work correctly. See attachement.

this is fixed in the meanwihle, for the other issues a follow up ticket exists (#9846)
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib/revisions/07dbf1bcf8687df44cd3e5fcb90acedb4a6a71f6
https://dev.e-taxonomy.eu/redmine/issues/9846

#14 - 11/03/2021 02:33 PM - Katja Luther

- Related to bug #9846: Improve delete configuration in specimen list editor added

#15 - 11/03/2021 02:34 PM - Katja Luther
- Status changed from Feedback to Closed

#16 - 11/03/2021 02:34 PM - Katja Luther
- % Done changed from 80 to 100

Files

NLS_error.png 14.7 KB 06/15/2017 Andreas Muller
